{ Shapes  Screen Saver              }
{ Copyright (c) 2000 by Adam Boduch }
{  E-mail: boduch@poland.com        }
{ http://www.programowanie.of.pl    }

unit FormNR1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, BarPopupMenu;

{$R MIKOLAJ.RES}

type
  TMainFrm = class(TForm)
    MainPopup: TBarPopupMenu;
    About: TMenuItem;
    N1: TMenuItem;
    Exit: TMenuItem;
    N2: TMenuItem;
    Opcje1: TMenuItem;
    N3: TMenuItem;
    Tekst: TMenuItem;
    Elipsy: TMenuItem;
    Linie: TMenuItem;
    N4: TMenuItem;
    Repain: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure TekstClick(Sender: TObject);
    procedure ElipsyClick(Sender: TObject);
    procedure LinieClick(Sender: TObject);
    procedure RepainClick(Sender: TObject);
  private
    { Private declarations }
    Done : Boolean;
    procedure RandomEvent;
    {====================}
    procedure TextDisplay(Sender: TObject);
    procedure Lines(Sender: TObject);
    procedure Ellipse(Sender: Tobject);
    procedure MoveImage(Sender: TObject);
  public
    DisplayTx : String;
  end;

var
  MainFrm: TMainFrm;

implementation



{$R *.DFM}

procedure TMainFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Done := True;
end;

procedure TMainFrm.Button1Click(Sender: TObject);
begin
  Ellipse(Self);
end;

procedure TMainFrm.Button2Click(Sender: TObject);
begin
  Done := True;
  Application.Terminate;
end;

procedure TMainFrm.FormCreate(Sender: TObject);
begin
  BorderStyle := bsNone;
  WindowState := wsMaximized;
  DisplayTx := 'Mamy dzisiaj: ' + DateToStr(Date);
end;

procedure TMainFrm.TextDisplay(Sender: TObject);
var
  Bitmap : TBitmap;
  I : Integer;
  Ran : Integer;
begin

  Bitmap := TBitmap.Create;

  Bitmap.Width := Width;
  Bitmap.Height := 60;
  Bitmap.Canvas.Font.Name := 'Arial Bold';
  Bitmap.Canvas.Font.Size := 26;
  Bitmap.Canvas.Brush.Color := clBlack;
  Bitmap.Canvas.FillRect(Rect(0, 0, Width, 60));


  while not Done do
  begin
    Randomize;
    Ran := Random(Height);
    Repaint;
    for I := 0 to Width do
    begin
      Application.ProcessMessages;
      Sleep(10);
      if (Done) then
        Break;
      Sleep(1);
      Bitmap.Canvas.Font.Color := clSilver;
      Bitmap.Canvas.Brush.Style := bsClear;
      Bitmap.Canvas.TextOut(2, 12, DisplayTx);
      Bitmap.Canvas.Font.Color := clWhite;
      Bitmap.Canvas.Brush.Style := bsClear;
      Bitmap.Canvas.TextOut(0, 10, DisplayTx);
      Canvas.Draw(I, Ran, Bitmap);
        if I = Width then
          RandomEvent;
    end;
  end;
  Bitmap.Free;
end;

procedure TMainFrm.Ellipse(Sender: TObject);
var
  X, Y : Integer;
  Shape : Integer;
begin
  Shape := Random(6);
  with Canvas.Brush do
  begin
    case Shape of
      1: Style := bsSolid;
      2: Style := bsCross;
      3: Style := bsVertical;
      4: Style := bsBDiagonal;
      5: Style := bsDiagCross;
    end;
  end;

  X := Width div 2;
  Y := Height div 2;
  Canvas.Brush.Color := clWhite;
  Canvas.Ellipse(X, Y, X + 10, Y + 10);
    while not Done do
    begin
      Application.ProcessMessages;
      X := Succ(X);
      Y := Succ(Y);
     Canvas.Ellipse(X, Y, Width - X, Height - Y);
      if Done then
        Break;
      if Y = Height then
        RandomEvent;
    end;
end;

procedure TMainFrm.RandomEvent;
var
  Event : Byte;
begin
  Event := Random((3) + 1);
    case Event of
      1: Ellipse(Self);
      2: TextDisplay(Self);
      3: Lines(Self);
      4: MoveImage(Self);
    end;
end;

procedure TMainFrm.Lines(Sender: TObject);
var
  I : Integer;
begin
  Repaint;
  Canvas.Brush.Color := clWhite;
  Canvas.Brush.Style := bsSolid;
   while not Done do
    begin
      for I:=0 to 1000 do
      begin
        Application.ProcessMessages;
        Canvas.Pen.Color := RGB(Random(255), Random(255), Random(255));

        Sleep(10);

      Canvas.MoveTo(
      Random(Width), Random(Height));
      Canvas.LineTo(
      Random(Width), Random(Height));

      if I = 1000 then
        RandomEvent;

      if Done then
        Break;
      end;
    end;
end;

procedure TMainFrm.FormActivate(Sender: TObject);
begin
  MoveImage(Self);
end;

procedure TMainFrm.Button3Click(Sender: TObject);
begin
  Ellipse(Self);
end;

procedure TMainFrm.AboutClick(Sender: TObject);
begin
  Messagebox(Handle, 
  ' "Shapes - Screen Saver" '+#13+#13+
  ' Copyright (c) 2000 by Adam Boduch '+#13+#13+
  ' http://www.programowanie.of.pl '+#13+
  ' E-mail: boduch@poland.com ', 'Info...',
  MB_OK + MB_ICONINFORMATION);
end;

procedure TMainFrm.ExitClick(Sender: TObject);
begin
  Done := True;
  Close;
end;

procedure TMainFrm.TekstClick(Sender: TObject);
begin
  TextDisplay(Self);
end;

procedure TMainFrm.ElipsyClick(Sender: TObject);
begin
  Ellipse(Self);
end;

procedure TMainFrm.LinieClick(Sender: TObject);
begin
  Lines(Self);
end;

procedure TMainFrm.RepainClick(Sender: TObject);
begin
  Repaint;
end;

procedure TMainFrm.MoveImage(Sender: TObject);
var
  B : TBitmap;
  I: Integer;
begin
  B := TBitmap.Create;
  B.LoadFromResourceName(hInstance, 'MIKOLAJ');
  B.Width := 99;
  B.Height := 120;


  while not Done do
  begin
    Application.ProcessMessages;
  for I:=0 to Width do
  begin
    Application.ProcessMessages;
    Sleep(10);
    Canvas.Draw(I, 100, B);
      if I = Width then
        RandomEvent;
      if Done then
        Break;
    end;
  end;
end;

end.

